C
C
C    ARITVE: PROGRAMME DE SIMULATION DES FONCTIONS D'INTERFERENCE
C                       D'AMORPHES.................
C
C          : A PROGRAM FOR MODELLING INTERFERENCE FUNCTIONS OF
C                       AMORPHOUS MATERIALS.................
C        
C     GAUSSIAN PEAK SHAPE WITH CAGLIOTTI LAW FOR THE FWHMs.....
C
C     MAIN PROGRAM
C
C     MAXIS;  70 REFINED PARAMETERS    
C             12000 HKL OVERLAP
C
      character*80 file
      DIMENSION XL(110,14),STAND(70)
      DIMENSION FLAG(110,14),LP(110,14),SMM(2485)
      DIMENSION DUMPA(500),S(3,4,21),F(3,4,21),SM(24,3,3),T(24,3)
      COMMON /RCEE/ RCE(3,6)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     2 6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)   
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)      
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2 ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3 ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /MAXDIM/MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM, 
     2 MNEQPO,MNOVRF,MNPATS
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT           
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      COMMON /RELX/RELAXB,RELAXC,RELAXS,RELAXH                     
      COMMON /GEOM/DEGRAD,RADDEG                                 
      COMMON /INPUT/NPOINT,MODE,LINO,READIN(6)
      PI=36000./3.14159265359           
      DEGRAD=3.14159265359/180.0  
      RADDEG=1.0/DEGRAD           
      LCA=20
      type 1
1     format('  entry file (no extension) ??',$)
      accept 3,file
3     format(A8)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
         lfile=lfile-1
      enddo
      call open_read1(20,file,'.dat')
      LPR=21
      call open_write1(21,file,'.imp')
      LPRE=22
      call open_read2(22,file,'.pre')
      LT4=23
      call open_write2(23,file,'.lt4')
      LT8=24
      call open_write3(24,file,'.lt8')
      LPT=27
      call open_write1(27,file,'.par')
      MNCONF=4 
      MNCONT=9 
      MMATOR=70
      MNEUTS=8 
      MNATOM=70
      MNEQPO=24
      MNOVRF=12000
      LINES=80 
      MNPATS=3 
      MODE=0   
      LINO=1   
      MATORD=0
10    ICYCLE=0   
      CALL DATAIN(XL,FLAG,LP,S,F,DUMPA,SM,T,LG)
30    ICYCLE=ICYCLE+1
      IF(NCYCLE)50,50,40 
40    IF(ICYCLE-NCYCLE)50,50,140
50    CALL CLEAR(SMM)
100   CALL ITER(DUMPA,XL,FLAG,LP,SMM,SM,T,LG,FILE,NCHR)
      IF(NCYCLE)120,120,110
110   CALL MATRIX(SMM,STAND)
120   CALL OUTPUT(XL,FLAG,LP,SMM,STAND)
      CALL DATOUT(XL,LPT)
130   IF(NCYCLE)180,180,30
140   NCYCLE=0            
      GOTO 50             
180   STOP
      END
      SUBROUTINE DATOUT(XL,LPT)
      DIMENSION XL(110,14)
      COMMON /RCEE/ RCE(3,6)
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     1ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)
      COMMON /SYMCEL/ ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),
     1    CELLN(6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)
      COMMON /NUMB/ N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
	DO 940 J=1,N
        WRITE(LPT,938)ATEXT(J)
940     WRITE(LPT,8000)NTYP(J),(XL(J,I),I=1,4)
8000  FORMAT(I2,4F9.5)
938   FORMAT(A4)
 1120 DO 1185 NP=1,NPAT
      N1=N+NP
      N3=N6+NP
 1180 WRITE(LPT,8001)XL(N1,3),XL(N3,1),XL(N3,2),XL(N3,3)
 1185 CONTINUE
      WRITE(LPT,8002) (RCE(1,I),I=1,6)
8001  FORMAT(1X,F12.5,3F12.1)
8002  FORMAT(1X,6F12.5)
      RETURN                                         
      END
      SUBROUTINE FLEES(AA,DUMPA)
      DIMENSION DUMPA(500)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LT9,LPUN    
      LLL=LLL+1                 
      AA=DUMPA(LLL) 
      IF(LLL.NE.500)GOTO 10     
      READ(LPRE,END=20)(DUMPA(I),I=1,500)    
      NKEY=NKEY+1               
      LLL=0                 
10    RETURN                
20    CONTINUE
      END                   
      SUBROUTINE PERM(I,J,K)
      IF(I-2)10,20,30    
10    J=2        
      K=3        
      RETURN     
20    J=3        
      K=1        
      RETURN     
30    J=1        
      K=2        
      RETURN     
      END        
      SUBROUTINE TRCL(CELLN,RCELLN,V)
      DIMENSION CELLN(6),RCELLN(6)
      DIMENSION SINA(3)
      ABC=1.0        
      PROD=2.0       
      V=-2.0
      DO 10 I=1,3    
      L=I+3          
      SINA(I)=1.0-CELLN(L)**2
      V=V+SINA(I)       
      SINA(I)=SQRT(SINA(I))     
      PROD=PROD*CELLN(L)     
10    ABC=ABC*CELLN(I)       
      V=ABC*SQRT(V+PROD)
      DO 20 I=1,3               
      CALL PERM(I,J,K)          
      RCELLN(I)=CELLN(J)*CELLN(K)*SINA(I)/V
      L=I+3                                              
20    RCELLN(L)=(CELLN(J+3)*CELLN(K+3)-CELLN(L))/(SINA(J) 
     2*SINA(K))
      RETURN                               
      END
      SUBROUTINE REPCEL(RCELLN,AL)
      DIMENSION RCELLN(6),AL(3,3)
      DO 10 I=1,3                    
10    RCELLN(I)=SQRT(AL(I,I))  
      DO 40 I=1,3         
      CALL PERM(I,J,K)    
      IF(J-K)30,40,20   
20    M=K               
      K=J               
      J=M               
30    RCELLN(I+3)=0.5*AL(J,K)/(RCELLN(J)*RCELLN(K))  
40    CONTINUE
      RETURN                                                
      END                                                   
      SUBROUTINE SHIFT(XL)
      DIMENSION XL(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      DO 40 NP=1,NPAT     
      N1=N+NP
      N3=N6+NP          
      AH(NP)=XL(N3,1)
      BH(NP)=XL(N3,2)
      CH(NP)=XL(N3,3)
40    SCALE(NP)=1.0/XL(N1,3)
      N2=N7+1
      DO 30 I=1,3              
      AL(I,I)=XL(N2,I)      
      CALL PERM(I,J,K)       
      IF(J-K)10,20,20        
10    AL(J,K)=XL(N2,I+3)  
      GOTO 30                
20    AL(K,J)=XL(N2,I+3)  
30    CONTINUE
      RETURN                 
      END                    
      SUBROUTINE PARS(I,NPAR)
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      IF(I-N)10,10,60       
10    CONTINUE
20    NPAR=8   
      RETURN   
50    NPAR=10  
      RETURN   
60    IF(I-N6)50,70,80
70    NPAR=3          
      RETURN          
80    IF(I-N7)90,90,100
90    NPAR=3   
      RETURN   
100   NPAR=6   
      RETURN   
      END      
      SUBROUTINE XCOPY(KK,CHAR,DUM) 
      DIMENSION DUM(70) 
      KK=KK+1           
      DUM(KK)=CHAR      
      RETURN            
      END               
      SUBROUTINE LOC(I,J,NU,MATORD) 
      IF(J.GE.I)GOTO 10   
      K=J                 
      J=I              
      I=K              
10    L=I-1            
      NU=MOD(L,2)      
      IF(NU)30,20,30   
20    NU=-(L*L+L)/2    
      GOTO 40          
30    NU=-L*(L/2+1)    
40    NU=NU+L*(MATORD+1)
      NU=NU+J-I+1       
      RETURN            
      END
      FUNCTION CIGN(A,B)          
      IF(B)10,20,10           
10    C=B                
      GOTO 30            
20    C=1.0              
30    CIGN=SIGN(A,C)     
      RETURN             
      END                
      SUBROUTINE CLEAR(SMM)
      DIMENSION SMM(2485)
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      SW=0.0      
      SUMAW=0.0   
      SUMW=0.0    
      DO 400 J=1,3  
      SUMOBS(J)=0.0  
400   SUMDIF(J)=0.0  
      SOM=0.0
      IF(NCYCLE.EQ.0)RETURN 
      DO 10 I=1,MATORD      
10    V(I)=0.0              
      DO 20 I=1,MATSIZ      
20    SMM(I)=0.0            
      RETURN                
      END
      SUBROUTINE DATAIN(XL,FLAG,LP,S,F,DUMPA,SM,T,LG)
      DIMENSION HH(3),IM(3,8),XL(110,14),LP(110,14),FLAG(110,14)
      DIMENSION DUMPA(500),S(3,4,21),F(3,4,21),SM(24,3,3),T(24,3)
      DIMENSION FA(4,10,3),FB(4,10,3),FC(10,3),DELFR(10,3)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     1ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)
      COMMON /SYMCEL/ ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),
     1CELLN(6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)
      COMMON /MINIM/ DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /MAXDIM/ MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM,
     1MNEQPO,MNOVRF,MNPATS
      COMMON /CONTRL/ NCYCLE,MAXS,KXR(3),KKZ,
     1ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     2ICYCLE,KLOOP,LINES
      COMMON /MATR/ MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN
      COMMON /NUMB/ N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /RELX/ RELAXB,RELAXC,RELAXS,RELAXH
      COMMON /INPUT/ NPOINT,MODE,LINO,READIN(6)
      DO 10 I=1,110
      DO 10 J=1,14
      FLAG(I,J)=0.
      LP(I,J)=0
10    XL(I,J)=0.
      READ(LCA,1) TEXT
      READ(LCA,*)NCYCLE,NPAT,MAXS,LG
      IF(NCYCLE.EQ.0)MAXS=0
      DO 25 NP=1,NPAT
      READ(LCA,6) (PTEXT(NP,J),J=1,4)
   25 CONTINUE
      READ(LCA,*)(KXR(NP),NP=1,NPAT)
      DO 30  NP=1,NPAT
      KXRNP=KXRNP+KXR(NP)
   30 CONTINUE
      N1=0 
      N2=0
      READ(LCA,*)ICENT,IRLL,NA,KL
      IRLL=IRLL+1
      N=NA
      KM=KL
      KLL=KL
      KMN=KM
   40 CONTINUE
      N4=N+3*NPAT+1
      N6=N+NPAT+1
      N7=N6+NPAT
      IF(KMN) 50,50,60
   50 KLOOP=1
      GOTO 70
   60 KLOOP=KMN
70    READ(LCA,*)(DLABDA(NP),NP=1,NPAT)
100   CONTINUE
      READ(LCA,*)RELAXC,RELAXB,RELAXS,RELAXH
      IF(RELAXC.LE.0.0) RELAXC=0.8
      IF(RELAXB.LE.0.0) RELAXB=0.8
      IF(RELAXS.LE.0.0) RELAXS=0.8
      IF(RELAXH.LE.0.0) RELAXH=0.8
  190 CONTINUE
      WRITE(LPR,161) TEXT
      WRITE(LPR,41)NCYCLE,MAXS,NPAT
      WRITE(LPR,2051) RELAXC,RELAXB,RELAXS,RELAXH
      DO 750 NP=1,NPAT
      WRITE(LPR,235) NP,(PTEXT(NP,J),J=1,4)
750   WRITE(LPR,21) DLABDA(NP)
235   FORMAT(/,1X,30(1H*),/,1X,1H*,7HPATTERN,I2,2X,4A4,1X,1H*,/,1X,
     A30(1H*))
185   DO 186 I=1,3
186   DLABDA(I)=0.25*DLABDA(I)*DLABDA(I)
200   READ(LPRE,END=220)(DUMPA(I),I=1,500)
210   LLL=1
      NKEY=1
      GOTO 230
220   CONTINUE
230   CALL FLEES(AA,DUMPA)
      LIMO=AA+0.5
      DO 470 I=1,3
      T(1,I)=0.
      DO 470 J=1,3
      IF(I-J) 410,400,410
  400 SM(1,I,J)=1.
      GOTO 470
  410 SM(1,I,J)=0.
  470 CONTINUE
      IRL=IRLL
      IF(IRL-1) 550,550,480
  480 CONTINUE
      DO 540 IR=2,IRL 
      READ(LCA,*)((SM(IR,I,J),J=1,3),I=1,3),(T(IR,I),I=1,3)
  540 CONTINUE
  550 CONTINUE
      IRL=IRLL
      IF(ICENT.EQ.2) GOTO 690
      WRITE(LPR,301)
      GOTO 700
  690 WRITE(LPR,303)
  700 IF(IRL-2) 7500,710,710
  710 WRITE(LPR,49)
      DO 740 IR=1,IRL
      WRITE(LPR,152) IR,((SM(IR,I,J),J=1,3),I=1,3),(T(IR,I),I=1,3)
  740 CONTINUE
7500  DO 751 J=1,NPAT
      IF(KXR(J).EQ.4) GO TO 559
560   READ(LCA,*)(B(J,I),I=1,KLL)
      GO TO 751
559   READ(LCA,*)(B(J,I),I=1,KMN)
      DO 561 I=1,KMN
561   READ(LCA,*)(FA(L,I,J),FB(L,I,J),L=1,4),FC(I,J),DELFR(I,J)
751   CONTINUE
      DO 788 J=1,NPAT
  790 WRITE(LPR,56) (B(J,I),I,I=1,KLL)
      IF(KXR(J).EQ.4)GO TO 810
      GO TO 788
810   DO 812 I=1,KMN
812   WRITE(LPR,62)(FA(L,I,J),FB(L,I,J),L=1,4),FC(I,J),DELFR(I,J)
788   CONTINUE
  930 CONTINUE
      WRITE(LPR,57)
      MODE=0
938   FORMAT(A4)
      DO 940 J=1,N
      READ(LCA,938)ATEXT(J)
940   READ(LCA,*)NTYP(J),(XL(J,I),I=1,4)
      CTOT=0.
      DO 1970 J=1,N
      CTOT=CTOT+XL(J,4)
1970  CONTINUE
      WRITE(LPR,171) (ATEXT(I),NTYP(I),(XL(I,J),J=1,4),I=1,N)
 1120 DO 1185 NP=1,NPAT
      N1=N+NP
      N3=N6+NP
      READ(LCA,*)XL(N1,3),XL(N3,1),XL(N3,2),XL(N3,3)
 1180 WRITE(LPR,66) XL(N1,3)
      WRITE(LPR,68)XL(N3,1),XL(N3,2),XL(N3,3)
 1185 CONTINUE
      N2=N7+1
      CALL DCELL
      DO 1200 I=1,3
 1200 XL(N2,I)=AL(I,I)
      XL(N2,4)=AL(2,3)
      XL(N2,5)=AL(1,3)
      XL(N2,6)=AL(1,2)
 1210 WRITE(LPR,76) (XL(N2,I),I=1,6)
      CALL FLEES(AA,DUMPA)
      NN=AA+0.5
      NN5=NN*5+3
 1315 CONTINUE
      IF(NCYCLE.LE.0)GOTO 1660
      WRITE(LPR,82)
      DO 1380 I=1,N
      READ(LCA,*)(FLAG(I,J),J=1,4)
 1380 CONTINUE
      WRITE(LPR,85) (ATEXT(I),(FLAG(I,J),J=1,4),I=1,N)
 1420 DO 1560 NP=1,NPAT
      N1=N+NP
      READ(LCA,*)FLAG(N1,3)
 1465 WRITE(LPR,89) FLAG(N1,3)
 1560 CONTINUE
      DO 1570 NP=1,NPAT
      N3=N6+NP
      READ(LCA,*)FLAG(N3,1),FLAG(N3,2),FLAG(N3,3)
      WRITE(LPR,91)FLAG(N3,1),FLAG(N3,2),FLAG(N3,3)
 1570 CONTINUE
      N2=N7+1
      READ(LCA,*)(FLAG(N2,J),J=1,6)
      WRITE(LPR,93)(FLAG(N2,J),J=1,6)
      DO 1610 I=1,N4
      CALL PARS(I,NPAR)
      DO 1600 J=1,NPAR
      X=FLAG(I,J)
      Y=INT(ABS(X))/10
      LP(I,J)=Y+0.5
 1600 FLAG(I,J)=(ABS(X)-10.*Y)*CIGN(1.,X)
 1610 CONTINUE
      MATORD=MAXS
      MATSIZ=MATORD*(MATORD+1)
      MATSIZ=MATSIZ/2
1660  CONTINUE
1680  CALL SHIFT(XL)
      FLOG =4.*ALOG(2.)
      FLOG2=2.*FLOG
      SLOG =1./SQRT(FLOG)
      CLOSE(UNIT=LCA,DISPOSE='KEEP')
      DO 1960 I=1,NN
      CALL FLEES(AA,DUMPA)
      ICODE=AA+0.5
      ICODD=ICODE/10
      ICODE=ICODE-ICODD*10
      NP  =ICODD
      DO 1830 J=1,3
      CALL FLEES(AA,DUMPA)
1830  HH(J)=AA
      CALL FLEES(AA,DUMPA)
      SJJ=AA
      X=0.
      DO 1840 J=1,3
      DO 1840 K=J,3
 1840 X=AL(J,K)*HH(  J)*HH(  K)+X
      IC=ICODE
      IF(IC.GE.4)IC=1
 1910 X=SQRT(X)*0.5
      FF(1)=0.
      IF(KXR(NP).NE.4)GO TO 1950
 1920 CONTINUE
      DO 1930 J=1,KMN
      FF(J)=0.
      DO 1930 K=1,4
      AR=-FB(K,J,NP)*X**2
      FF(J)=FF(J)+FA(K,J,NP)*EXP(AR)
1930  CONTINUE
      DO 1940 J=1,KMN
1940  FF(J)=FF(J)+DELFR(J,NP)+FC(J,NP)
C
C      CALCUL DE <F**2>
C
      FAC=0.
      DO 1980 J=1,N
      FAC=FAC+XL(J,4)*(FF(NTYP(J))**2+B(NP,NTYP(J))**2)
1980  CONTINUE
      FAC=FAC/CTOT
 1950 WRITE(LT8)(HH(J),J=1,3),ICODE,ICODD,SJJ,FAC,(FF(J),J=1,KLOOP)
 1960 CONTINUE                                                         
    1 FORMAT(20A4)                                                     
    6 FORMAT(4A4)                                                      
   21 FORMAT('   WAVELENGTH',F8.5)
   41 FORMAT(1H ,I3,27H CYCLE(S) OF REFINEMENT OF ,I3,13H PARAMETER(S),
     12X,4H FOR,I2,9H PATTERNS)                                        
   49 FORMAT(1H+,38X,33HAND THE EQUIVALENT POSITIONS ARE:)        
   51 FORMAT('  SCATTERING LENGTHS'/)             
   56 FORMAT(1H0,8(F8.4,5H = B(,I1,2H);))                         
   57 FORMAT(/52X,18HINITIAL PARAMETERS   /' ATOM  NTYP',6X
     1,1HX,9X,1HY,9X,1HZ,9X,1HN/)        
   61 FORMAT(11H0ATOM TYPE ,I2)                          
   62 FORMAT(2X,10F10.6)               
   65 FORMAT(A4,I4,5F8.5,2I4,3F8.4)                      
   66 FORMAT(22H0OVERALL SCALE FACTORS,2F12.7)
   68 FORMAT('   U V W     PARAM. ',3F12.4)
   75 FORMAT(6F10.8)                               
   76 FORMAT(16H CELL CONSTANTS ,6X,6F10.7)        
   82 FORMAT(1H ,50X,19HCODING OF VARIABLES/5H ATOM,24X,1HX,9X,1HY,9X,1H 
     1Z,9X,1HN)   
   85 FORMAT(1X,A4,17X,4F10.2)                   
   89 FORMAT(22H0OVERALL SCALE FACTORS,2F10.2)
   91 FORMAT(22H  U V W    PARAMETERS ,3F10.2)   
   93 FORMAT(16H CELL CONSTANTS ,6X,6F10.2)      
  159 FORMAT(30H0REAL X-RAY SCATTERING FACTORS)        
  152 FORMAT(9H0POSITION ,I3,10X,9F6.1,3F10.5)     
  161 FORMAT(/1H ,20X,20A4/)                       
  171 FORMAT(1X,A4,I3,4F10.5)               
  215 FORMAT(32H INCORRECT FILE LOADED ON UNIT 3)         
  301 FORMAT('   NON CENTRO.,')   
  303 FORMAT('   CENTRO.,')
 2051 FORMAT(/,1X,23HRELAXATION FACTORS FOR:,/,      
     A6X,17HATOMIC PARAMETERS,10X,F4.2,/,            
     B6X,19H    UNUSED         ,8X,F4.2,/,           
     C6X,25HSCALE,OCCUPATION         ,2X,F4.2,/,     
     D6X,25HHALFWIDTHS,CELL          ,2X,F4.2)       
      RETURN                                         
      END
      SUBROUTINE DCELL
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /GEOM/DEGRAD,RADDEG                                       
      COMMON /INPUT/NPOINT,MODE,LINO,READIN(6)
      EQUIVALENCE (VOL,V)  
      DO 10 I=1,3       
      DO 10 J=1,3
10    AL(I,J)=0.0
      READ(LCA,*)(READIN(I),I=1,6)
      IF(READIN(1)-1.0)20,60,60 
20    ICELL=1                   
      DO 50 I=1,3               
      AL(I,I)=READIN(I)      
      CALL PERM(I,J,K)          
      IF(J-K)30,40,40           
30    AL(J,K)=READIN(I+3)    
      GOTO 50                   
40    AL(K,J)=READIN(I+3)    
50    CONTINUE               
      GOTO 140               
60    ICELL=0                
      DO 70 I=1,6            
      CELLN(I)=READIN(I)  
70    CONTINUE               
      DO 100 I=1,3           
      L=I+3                  
      IF(CELLN(L)-90.0)90,80,90
80    CELLN(L)=0.0             
      GOTO 100                    
90    CELLN(L)=COS(DEGRAD*CELLN(L)) 
100   CONTINUE                            
      CALL TRCL(CELLN,RCELLN,V)        
      DO 130 I=1,3                        
      AL(I,I)=RCELLN(I)*RCELLN(I)
      CALL PERM(I,J,K)                    
      IF(J-K)110,120,120                  
110   AL(J,K)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3)
      GOTO 130                                               
120   AL(K,J)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3)
130   CONTINUE
      RETURN                        
140   CALL REPCEL(RCELLN,AL)     
      CALL TRCL(RCELLN,CELLN,V)  
      V=1.0/V               
      RETURN                        
      END                           
      SUBROUTINE ITER(DUMPA,XL,FLAG,LP,SMM,SM,T,LG,FILE,NCHR)
      character*80 file
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14),SMM(2485)
      DIMENSION IH(3),THET(1000),SM(24,3,3),T(24,3)
      DIMENSION DUMPA(500)
      DIMENSION AOBS(3,1000),ACAL(3,1000)
      COMMON /BIG/DERSTO(12000,70),FNUC(12000),HW(12000),SOMEGA(12000),
     2HH(3,12000),ICODE(12000),SJJ(12000),THETA(12000),ICODD(12000)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /MAXDIM/ MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM,
     1MNEQPO,MNOVRF,MNPATS
      REWIND LT8 
      IDO=1
      MMM=0      
      NUM=0      
      IF(NCYCLE)30,20,30
20    CONTINUE
30    REWIND LPRE     
      LLL=499
      CALL FLEES(AA,DUMPA)
      X=AA
      NK=NN5          
40    IF(NK-500)60,50,50
50    LLL=499           
      CALL FLEES(AA,DUMPA)
      X=AA
10    FORMAT(10X,F10.3)  
      NK=NK-500    
      GOTO 40      
60    LLL=NK
      IPREV=1
      IOLD1=0
      NPP=0
      NT=0
      DO 290 JKK=1,NPAT
      CALL FLEES(AA,DUMPA)       
      IALFA(JKK)=AA+0.5
      CALL FLEES(AA,DUMPA)
      ISTAP(JKK)=AA+0.5
      CALL FLEES(AA,DUMPA)
      IOMEG(JKK)=AA+0.5
      IDO=IALFA(JKK)  
90    NSTAP=ISTAP(JKK) 
      NOMEG=IOMEG(JKK)
      ARG=SQRT(3.14159265359)/FLOAT(ISTAP(JKK))
      NO=0
      DO 270 IST=IDO,NOMEG,NSTAP
      CALL FLEES(AA,DUMPA)
      YOBS=AA      
      NO=NO+1                   
      IF(ABS(YOBS).GE.0.001)GOTO 190
      CALL FLEES(AA,DUMPA)
      ISS=AA+0.5
      YOBS=0.0                      
      YCALC=0.0
      GOTO 240                      
190   NUM=NUM+1
      CALL FLEES(AA,DUMPA)             
      W=AA
      SW=SW+W
      CALL FLEES(AA,DUMPA)
      IORD1=AA+0.5
      CALL FLEES(AA,DUMPA)
      IORD2=AA+0.5
      CALL FLEES(AA,DUMPA)
      ISS=AA+0.5
      IF(IPREV.GT.IORD2)GOTO 230
      IFIN=IORD1-1              
210   IOLD1=IORD1
      DO 220 J=IPREV,IORD2    
220   CALL CALCUL(J,XL,FLAG,LP,SM,T)
230   IPREV=IORD2+1
      CALL SUMMAT(SMM,LP,XL,LG)
      IF(LG.EQ.0)TYPE 235,YOBS,YCALC
235   FORMAT(2X,2F12.2)
240   IF(NCYCLE)260,250,260   
250   CALL PROFOT(MMM,JKK,NPP,NT,AOBS,ACAL)        
260   IF(ISS.GE.IOMEG(JKK))GOTO 290
270   CONTINUE                
290   CONTINUE
      IF(NCYCLE)310,300,310
300   MMM=1                   
      CALL PROFOT(MMM,JKK,NPP,NT,AOBS,ACAL)
C
C  SORTIE DES FICHIERS .PRF
C
      DO 309 NPP=1,NPAT
      LTT=14+NPP
      GOTO(301,302,303),NPP
301   call open_write1(ltt,file,'.pr1')
      GO TO 304
302   call open_write1(ltt,file,'.pr2')
      GO TO 304
303   call open_write1(ltt,file,'.pr3')
304   THMAX=IOMEG(NPP)/100.
      TH0=IALFA(NPP)/100.
      STP=ISTAP(NPP)/100.
      WRITE(LTT,3421)THMAX,TH0,STP
3421  FORMAT(//,3F8.3)
      NPHASE=NPP
      ABMES=(THMAX-TH0)/STP+1.5
      NBMES=ABMES
      WRITE(LTT,3422)NPHASE,NBMES
3422  FORMAT(I3,I5)
      IC1=1
      IC2=1
      WRITE(LTT,3423)IC1,IC2
3423  FORMAT(2I5)
      WRITE(LTT,3424)(AOBS(NPP,J),J=1,NBMES)
      WRITE(LTT,3424)(ACAL(NPP,J),J=1,NBMES)
3424  FORMAT(8(F7.0,1X))
309   CONTINUE
310   CONTINUE
320   CONTINUE
330   FORMAT(3I6/)         
340   FORMAT(/)            
350   FORMAT(1H1)          
360   FORMAT(/I8)          
370   FORMAT(3I8)             
390   FORMAT(I8,F8.1)      
400   FORMAT('   -1000',/,'  -10000',/,I8)
	RETURN
      END                                     
      SUBROUTINE SUMMAT(SMM,LP,XL,LG)
      DIMENSION LP(110,14),SMM(2485),XL(110,14)
      COMMON /BIG/DERSTO(12000,70),FNUC(12000),HW(12000),SOMEGA(12000),
     2HH(3,12000),ICODE(12000),SJJ(12000),THETA(12000),ICODD(12000)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)          
      COMMON /MAXDIM/MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM, 
     2MNEQPO,MNOVRF,MNPATS
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      DATA PII/3.1415926/
      IF(NCYCLE)30,30,10     
10    DO 20 J=1,MATORD       
20    DERIV(J)=0.            
30    YCALC=0.               
      BCALC=0.               
      DO 190 I=IORD1,IORD2   
      J=MOD(I,MNOVRF)+1
      NP=ICODD(J)            
      N2=N7+1
      N3=N6+NP
      DELTA=FLOAT(ISS)-THETA(J)
      DELT=DELTA*DELTA
      BB=HW(J)*HW(J)
      OMEGA=SJJ(J)*EXP(-DELT/BB)/HW(J)
      OMEF=OMEGA*FNUC(J)
      BCALC=BCALC+OMEF               
      YCALC=YCALC+OMEF/SCALE(NP)  
      SOMEGA(J)=SOMEGA(J)+OMEGA    
      IF(NCYCLE.EQ.0)GOTO 190
      X=(2.0*DELT/BB)-1.0
      DO 180 K=1,MATORD 
      DER=1.
      DO 90 M=1,3
      IF(LP(N3,M)-K)90,80,90    
80    DER=X
      GOTO 170
90    CONTINUE
      DO 160 M=1,6                 
      IF(LP(N2,M)-K)160,150,160    
150   DER=DELTA            
      GOTO 170                  
160   CONTINUE                  
170   CONTINUE                  
      DERIV(K)=DERSTO(J,K)*DER*OMEGA+DERIV(K)
180   CONTINUE                                 
190   CONTINUE
260   DELTA=YOBS-YCALC                      
      SUMW=SUMW+W*DELTA*DELTA        
      SUMOBS(NP)=SUMOBS(NP)+ABS(YOBS)     
      SUMDIF(NP)=SUMDIF(NP)+ABS(DELTA)    
      IF(YCALC)300,310,300        
300   XX=DELTA*BCALC/YCALC        
      SUMAW=SUMAW+W*XX*XX       
310   IF(NCYCLE.EQ.0)GOTO 330     
      DELTA=XX        
      L=0
      DO 320 I=1,MATORD           
      X=W*DERIV(I)                
      V(I)=V(I)+DELTA*X           
      DO 320 J=I,MATORD         
      L=L+1                     
      SMM(L)=SMM(L)+X*DERIV(J)  
320   CONTINUE                  
330   RETURN                    
      END                       
      SUBROUTINE PROFOT(MMM,JKK,NPP,NT,AOBS,ACAL)
      DIMENSION KK(500),OBS(10),CALC(10),IOBS(10),ICALC(10)
      DIMENSION AOBS(3,1000),ACAL(3,1000)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     3ICYCLE,KLOOP,LINES
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      IF(MMM)190,30,190
30    MO=MOD(NO,10)       
      IF(MO)40,40,50      
40    MO=10               
50    NPP=NPP+1           
      IF(NPP-1)60,60,70   
60    IALFA(JKK)=ISS           
70    IF(MO-1)90,80,90               
80    NT=NT+1                        
      KK(NT)=ISS                     
90    IOBS(MO)=YOBS+CIGN(0.5,YOBS)   
      OBS(MO)=YOBS                   
      ICALC(MO)=YCALC+CIGN(0.5,YCALC)
      CALC(MO)=YCALC                 
      IF(MO-10)100,120,120        
100   IF(ISS-IOMEG(JKK))180,110,110    
110   CONTINUE
120   CONTINUE
130   WRITE(LT4)(OBS(J),J=1,10),(CALC(J),J=1,10)
      IF(JKK.NE.NPAT)GO TO 180
150   IF(ISS-IOMEG(JKK))180,160,160                                 
160   CONTINUE
      WRITE(LT4)(OBS(J),J=1,10),(CALC(J),J=1,10)               
170   FORMAT(20A4,/,'      10       0',F8.2,'       0       1',/,F8.2,/)
      ENDFILE LT4
      REWIND LT4 
180   RETURN     
190   NT=1       
      NL=LINES
      N0=0
200   K=MOD(NT,NL)-1
220   IF(NPP-10)230,240,240
230   K=NPP                
      IF(K)180,180,250     
240   K=10                 
250   READ(LT4)(OBS(J),J=1,10),(CALC(J),J=1,10)
      IF(KK(NT).EQ.0)N0=N0+1
      IF(KK(NT).EQ.0)L0=1
      IF(L0.EQ.1)WRITE(LPR,290)N0
      DO 260 J=1,K                             
      IOBS(J)=OBS(J)+CIGN(0.5,OBS(J))          
      ICALC(J)=CALC(J)+CIGN(0.5,CALC(J))       
      AOBS(N0,L0)=OBS(J)
      ACAL(N0,L0)=CALC(J)
      L0=L0+1
260   CONTINUE                                 
      WRITE(LPR,270)KK(NT),(IOBS(J),ICALC(J),J=1,K)
      NT=NT+1                                      
      NPP=NPP-10                                   
      GOTO 200                                     
270   FORMAT(1X,I6,2X,20I6)                
280   FORMAT(10I8)                                 
290   FORMAT(//10X,'INTERFERENCE FUNCTION NUMBER ',I2,
     A/9H1POSITION,10(12H  YOBS YCALC))       
      END                                          
      SUBROUTINE CALCUL(JJ,XL,FLAG,LP,SM,T)
      DIMENSION HNN(3),AX(3),BX(3),RSAI(3,3),RSBI(3,3),AXI(3),BXI(3),  
     2DSA(3),DSB(3),DAX(3),DBX(3),HOVD(3)
      DIMENSION COSAR(70,24),SINAR(70,24),XL(110,14),SM(24,3,3),T(24,3)
      DIMENSION FLAG(110,14),LP(110,14)
      DIMENSION COSARI(24),SINARI(24),SNEX(70),TR(24)
      COMMON /BIG/DERSTO(12000,70),FNUC(12000),HW(12000),SOMEGA(12000),
     2HH(3,12000),ICODE(12000),SJJ(12000),THETA(12000),ICODD(12000)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN
      COMMON /MAXDIM/MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM,
     2MNEQPO,MNOVRF,MNPATS
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      DATA FACCUB/0.666666666667/,PII/3.1415926/
      NM=MOD(JJ,MNOVRF)+1
      READ(LT8)(HH(I,NM),I=1,3),ICODE(NM),ICODD(NM),SJJ(NM),FAC,
     2 (FF(I),I=1,KLOOP)
      SOMEGA(NM)=0.
      FNUC(NM)=0.
      IF(NCYCLE)4,4,2
2     DO 3 I=1,MAXS
3     DERIV(I)=0.
4     CONTINUE
      DO 6 I=1,3
6     HNN(I)=HH(I,NM)
      DO 10 I=1,MATORD                  
10    DERIV(I)=0.0
      NP=ICODD(NM)
      N2=N7+1
      N3=N6+NP
      DO 40 IR=1,IRLL
      TR(IR)=0.
      DO 30 I=1,3
      H(IR,I)=0.
      TR(IR)=TR(IR)+T(IR,I)*HNN(I)
      DO 20 J=1,3
20    H(IR,I)=SM(IR,J,I)*HNN(J)+H(IR,I)
30    CONTINUE
40    CONTINUE
      SLABDA=DLABDA(NP)
      SS=0.                     
      DO 50 I=1,3                    
      DO 50 J=I,3                    
50    SS=AL(I,J)*HNN(I)*HNN(J)+SS
      SSNN=0.25*SS
      SINTH=SLABDA*SS
      COSTH=1.-SINTH
      TANTH=SQRT(SINTH/COSTH)
      THETA(NM)=ATAN(TANTH)*PI
      HW(NM)=SQRT(AH(NP)*TANTH*TANTH+BH(NP)*TANTH+CH(NP))*SLOG
      BB=HW(NM)**2
      DO 130 I=1,N
      DO 120 IR=1,IRLL
      ARG=TR(IR)             
      DO 70 J=1,3               
70    ARG=ARG+H(IR,J)*XL(I,J)   
      ARG=6.28318530718*ARG
      COSAR(I,IR)=COS(ARG)
120   SINAR(I,IR)=SIN(ARG)
130   CONTINUE
      AV=0.                     
      BV=0.                     
      DO 170 I=1,N              
      IF(NTYP(I).EQ.0)GOTO 170
      SNXI=0.                   
      SAI=0.                    
      SBI=0.                    
      DO 140 IR=1,IRLL           
      SAI=SAI+COSAR(I,IR)         
      IF(ICENT.EQ.1)SBI=SINAR(I,IR)+SBI 
140   CONTINUE                          
      SAI=FLOAT(ICENT)*SAI    
      SA(I)=SAI            
      SB(I)=SBI            
      NI=NTYP(I)           
      BNI=B(NP,NI)            
      IF(KXR(NP).LT.4)GOTO 150 
      SNEXI=FF(NI)    
      SNXI=BNI*XL(I,4)
      GOTO 160                
150   SNEXI=BNI       
160   AV=SNEXI*SAI*XL(I,4)+AV 
      BV=SNEXI*SBI*XL(I,4)+BV
      SNEX(I)=2.*SNEXI
      IF(KXR(NP).LT.4)GOTO 170 
      AVI=AV-SNXI*SBI         
      AVJ=AV+SNXI*SBI         
      BVI=BV-SNXI*SAI         
      BVJ=BV+SNXI*SAI         
170   CONTINUE
190   IF(KXR(NP).LT.4)GOTO 200 
      FNN=(AVI*AVI+AVJ*AVJ+BVI*BVI+BVJ*BVJ)/2./FAC
      GOTO 210                 
200   FNN=(AV*AV+BV*BV)
210   FNUC(NM)=FNN
      IF(NCYCLE.EQ.0)GOTO 350 
      DO 340 I=1,N            
      IF(NTYP(I).EQ.0)GOTO 340
      SNEXI=SNEX(I)*XL(I,4)
      SAI=SA(I)               
      SBI=SB(I)               
      DO 220 IR=1,IRLL         
      SINARI(IR)=SINAR(I,IR)  
220   COSARI(IR)=COSAR(I,IR)  
      CALL PARS(I,NPAR)
      DO 330 J=1,NPAR
      IF(J.LT.9.AND.J.GT.5)GO TO 330         
      K=LP(I,J)                    
      IF(K.EQ.0)GOTO 330
230   GOTO(240,240,240,270),J  
240   SUMA=0.                      
      SUMB=0.                      
      DO 250 IR=1,IRLL              
      SUMA=H(IR,J)*SINARI(IR)+SUMA 
      IF(ICENT.EQ.1)SUMB=H(IR,J)*COSARI(IR)+SUMB
250   CONTINUE                                  
      DER=-(AV*SUMA-BV*SUMB)*SNEXI*FLOAT(ICENT)*6.28318530718  
      GOTO 320
270   DER=(SAI*AV+SBI*BV)*SNEX(I)   
320   DERIV(K)=FLAG(I,J)*DER+DERIV(K)              
330   CONTINUE                                     
340   CONTINUE                         
      CALL DOVER(FNN,SSNN,NP,LP,FLAG)    
350   CONTINUE
1000  FNN=FNUC(NM)            
      IF(NCYCLE.EQ.0)GOTO 1160
      SINTH=FNN*PI*SLABDA/(SQRT(SINTH*COSTH)*BB) 
      SS=FNN/(FLOG2*BB)
      X=TANTH*TANTH
      DO 1010 J=1,3
      K=LP(N3,J)
      IF(K.EQ.0)GOTO 1010          
      DERIV(K)=X*FLAG(N3,J)*SS+DERIV(K) 
1010  X=X/TANTH
      DO 1050 J=1,6             
      K=LP(N2,J)                
      IF(K.EQ.0)GOTO 1050       
      IF(J-3)1020,1020,1030     
1020  K1=J                   
      K2=J                   
      GOTO 1040              
1030  M=J-3                  
      CALL PERM(M,K1,K2)     
1040  DERIV(K)=DERIV(K)+HNN(K1)*HNN(K2)*SINTH*FLAG(N2,J) 
1050  CONTINUE                                       
      DO 1060 I=1,MATORD                                           
C      IF(ISW.NE.0)DERIV(I)=DERIV(I)/SCALE(NP)                    
1060  DERSTO(NM,I)=DERIV(I)                                        
1160  RETURN       
      END          
      SUBROUTINE DOVER(FNN,SSNN,NP,LP,FLAG)
      DIMENSION LP(110,14),FLAG(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      N1=N+NP               
      DO 70 J=1,5     
      K=LP(N1,J)      
      IF(K.EQ.0)GOTO 70     
      IF(K-MATORD)10,10,70  
10    GOTO(20,70,30,40,50),J
20    DER=0.         
      GOTO 60               
30    DER=SCALE(NP)*FNN   
      GOTO 60               
40    CONTINUE   
      GOTO 60               
50    DER=-2.0*SSNN*FNN     
60    DERIV(K)=DERIV(K)+FLAG(N1,J)*DER 
70    CONTINUE                         
      RETURN                           
      END                              
      SUBROUTINE MATRIX(SMM,STAND)
      DIMENSION STAND(70),SMM(2485)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LT9,LPUN                      
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      NFAIL=0
      JJ=MATORD*(MATORD+1)/2
      CALL MATINV(NFAIL,SMM)
      DO 110 I=1,MATORD     
      DERIV(I)=0.0          
      II=I                  
      IID=MATORD-1          
      DO 100 J=1,MATORD     
      DERIV(I)=DERIV(I)+SMM(II)*V(J)                                   
      IF(J-I)80,90,90       
80    II=II+IID   
      IID=IID-1   
      GOTO 100    
90    II=II+1     
100   CONTINUE    
110   CONTINUE    
      SIGD=SQRT(SUMAW/FLOAT(NUM-MATORD))                               
      II=1        
      IID=MATORD  
      DO 130 I=1,MATORD                                                
      STAND(I)=SQRT(SMM(II))*SIGD                                      
      II=II+IID   
      IID=IID-1   
130   CONTINUE      
150   RETURN        
      END           
      SUBROUTINE MATINV(NFAIL,AM)                                         
      DOUBLEPRECISION TERM,DENOM,SUMA                                  
      DIMENSION AM(2485)                                               
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      EQUIVALENCE (MATORD,N)
      K=1            
      IF(N-1)10,20,30
10    NFAIL=1        
      GOTO 220       
20    AM(1)=1.0/AM(1)
      GOTO 210       
30    DO 120 M=1,N   
      IMAX=M-1       
      DO 110 L=M,N   
      SUMA=0.0D0     
      KLI=L          
      KMI=M          
      IF(IMAX)60,60,40
40    DO 50 I=1,IMAX  
      SUMA=SUMA+DBLE(AM(KLI)*AM(KMI))                                  
      J=N-I           
      KLI=KLI+J       
50    KMI=KMI+J       
60    TERM=DBLE(AM(K))-SUMA
      IF(L-M)70,70,100     
70    IF(TERM)90,90,80     
80    DENOM=DSQRT(TERM)    
      AM(K)=SNGL(DENOM)    
      GOTO 110             
90    NFAIL=K              
      GOTO 220             
100   AM(K)=SNGL(TERM/DENOM)
110   K=K+1            
120   CONTINUE         
130   AM(1)=1.0/AM(1)  
      KDM=1            
      DO 160 L=2,N     
      KDM=KDM+N-L+2    
      TERM=DBLE(1.0/AM(KDM))
      AM(KDM)=SNGL(TERM)
      KMI=0             
      KLI=L             
      IMAX=L-1          
      DO 150 M=1,IMAX   
      K=KLI             
      SUMA=0.0D0        
      DO 140 I=M,IMAX   
      II=KMI+I          
      SUMA=SUMA-DBLE(AM(KLI)*AM(II))                                   
140   KLI=KLI+N-I       
      AM(K)=SNGL(SUMA*TERM)                                            
      J=N-M            
      KLI=K+J          
150   KMI=KMI+J        
160   CONTINUE         
170   K=1              
      DO 200 M=1,N     
      KLI=K            
      DO 190 L=M,N     
      KMI=K            
      IMAX=N-L+1       
      SUMA=0.0D0       
      DO 180 I=1,IMAX  
      SUMA=SUMA+DBLE(AM(KLI)*AM(KMI))                                  
      KLI=KLI+1        
180   KMI=KMI+1        
      AM(K)=SNGL(SUMA) 
190   K=K+1            
200   CONTINUE         
210   NFAIL=0          
220   RETURN
      END
      SUBROUTINE OUTPUT(XL,FLAG,LP,SMM,STAND)
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14),STAND(70)
      DIMENSION SMM(2485)
      DIMENSION FMT(70)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT   
      IF(NCYCLE)90,90,10
10    CALL UPDATE(XL,FLAG,LP)
      CALL SHOUT(XL,FLAG,LP,STAND,FMT)
      CALL CELLSD(XL,FLAG,LP,SMM)
      IF(NCYCLE-ICYCLE)90,30,90
30    CONTINUE
90    CALL ROUT(NUM)        
120   CONTINUE
      RETURN
      END                                                     
      SUBROUTINE ROUT(NUM)                                    
      COMMON /RCEE/ RCE(3,6)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN    
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT   
      WRITE(LPR,160)ICYCLE
      TYPE 160,ICYCLE
C8001  FORMAT(6F11.6)
C      TYPE 8001,(RCE(1,I),I=1,6)
      DO 400 J=1,NPAT
      WRITE(LPR,260)J
      X=100.0*SUMDIF(J)/SUMOBS(J)   
      WRITE(LPR,180)X
      TYPE 180,X         
400   CONTINUE
160   FORMAT(1H0,47X,23HR FACTORS BEFORE CYCLE ,I3)
180   FORMAT(                                                          
     257H PROFILE INTENSITY R (100*SUM[ABS(Y<OBS>-Y<CALC>*SCALE)]/,   
     317HSUM[ABS(Y<OBS>)]),14X,F6.2)                                 
260   FORMAT(5X'  INTERFERENCE FUNCTION NUMBER  'I4)
      RETURN
      END        
      SUBROUTINE CELLSD(XL,FLAG,LP,SMM)
      DIMENSION COV(6,6),RCOV(6,6),D(6,6),P(6),DRSIN(3),
     2DRTAN(3),TCOV(6,6),RCSIN(3),SCOV(6,6),DVDP(6)
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14),SMM(2485)    
      COMMON /RCEE/ RCE(3,6)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /GEOM/DEGRAD,RADDEG   
      N2=N7+1                     
      DO 411 I=1,3
411   RCE(1,I)=CELLN(I)
      DO 412 I=4,6
412   RCE(1,I)=ACOS(CELLN(I))*RADDEG
      DO 20 I=1,6                  
      IF(LP(N2,I))20,20,10         
10    IF(LP(N2,I)-MATORD)30,30,20  
20    CONTINUE                     
      VOL=1.0/VOL  
      RETURN               
30    DO 40 I=1,6          
      P(I)=XL(N2,I)     
      DO 40 J=1,6          
      COV(I,J)=0.0      
      D(I,J)=0.0    
40    CONTINUE         
      G=1.0            
      DO 80 I=1,3      
      J=I+3            
      DRSIN(I)=SQRT(1.0-CELLN(J)*CELLN(J))
      IF(CELLN(J)-0.0000001)50,60,60
50    DRTAN(I)=1.0E15                           
      GOTO 70                                      
60    DRTAN(I)=DRSIN(I)/CELLN(J)          
70    RCSIN(I)=SQRT(1.0-RCELLN(J)*RCELLN(J))
      G=G*CELLN(I)*CELLN(I)*DRSIN(I)      
80    CONTINUE                    
      VS=2.0*VOL*VOL   
      G=G*VS             
      SD=SIGD*SIGD       
      DO 140 I=1,6       
      II=I               
      L1=LP(N2,II)       
      IF(L1)140,140,90   
90    IF(L1-MATORD)100,100,140  
100   DO 130 J=I,6           
      JJ=J                   
      L2=LP(N2,JJ)           
      IF(L2)130,130,110      
110   IF(L2-MATORD)120,120,130
120   CALL LOC(L1,L2,NU,MATORD) 
      COV(I,J)=SMM(NU)*FLAG(N2,II)*FLAG(N2,JJ)*SD
      COV(J,I)=COV(I,J)  
130   CONTINUE                 
140   CONTINUE                 
      CLIM=1.0E-6              
      DO 310 I=1,3             
      D(I,I)=-0.5*CELLN(I)/P(I) 
      L1=I+3               
      DO 300 J=1,3         
      L2=J+3               
      CALL PERM(J,K,L)     
      IF(J-I)170,150,170   
150   IF(ABS(CELLN(L2))-CLIM)200,160,160
160   D(L1,J)=2.0/DRTAN(J)           
170   IF(P(J)-CLIM)200,180,180          
180   IF(RCELLN(L1)-CLIM)200,190,190    
190   D(L1,J)=D(L1,J)+G*RCELLN(L1)
      D(L1,J)=1.0/(D(L1,J)*P(J)) 
200   IF(I-J)210,230,210                 
210   IF(ABS(P(L2))-CLIM)230,220,220  
220   D(I,L2)=-CELLN(I)/P(L2)   
230   IF(ABS(P(L2))-CLIM)250,240,240  
240   IF(ABS(RCELLN(L1))-CLIM)250,260,260
250   IF(I-J)300,260,300                       
260   D(L1,L2)=VS*CELLN(J)*CELLN(J)*CELLN(K)*CELLN(L) 
     2 *DRSIN(I)                                    
      IF(I-J)270,280,270                               
270   D(L1,L2)=-D(L1,L2)*CELLN(9-I-J)         
280   D(L1,L2)=D(L1,L2)+G*P(L2)*RCELLN(L1) 
290   D(L1,L2)=1.0/D(L1,L2)  
300   CONTINUE                   
310   CONTINUE                   
      CALL MATABT(RCOV,COV,D,NP) 
      CALL MATAB(TCOV,D,RCOV,NP) 
      DO 320 I=1,6   
      DO 320 J=1,6   
      D(I,J)=0.0  
320   CONTINUE       
      DO 380 I=1,3   
      D(I,I)=0.5/RCELLN(I) 
      L1=I+3                  
      DO 370 J=1,3            
      L2=J+3                  
      IF(J-I)330,350,330      
330   IF(RCELLN(L2)-CLIM)350,340,340  
340   D(I,L2)=2.0*(RCELLN(6-I-J)*RCELLN(L2))  
      GOTO 370                                         
350   CALL PERM(J,K,L)                                 
      D(L1,L2)=-2.0*(RCELLN(L)*RCELLN(K)*RCSIN(J))  
      IF(D(L1,L2))360,370,360     
360   D(L1,L2)=1.0/D(L1,L2)    
370   CONTINUE                       
380   CONTINUE                       
      CALL MATABT(RCOV,COV,D,NP)     
      CALL MATAB(SCOV,D,RCOV,NP)     
      VOL=1.0/VOL            
      G=0.5*G*VOL                
      CALL VESD(E1,G,VOL,CELLN,RCELLN,TCOV,DVDP,NP)  
      G=1.0                                          
      DO 390 I=1,3                                   
      G=G*RCELLN(I)*RCELLN(I)*RCSIN(I)      
390   CONTINUE                                   
      G=G*VOL                                
      VS=VOL                                 
      VOL=1.0/VOL                        
      CALL VESD(E2,G,VOL,RCELLN,CELLN,SCOV,DVDP,NP) 
      CALL CESD(TCOV,P,CELLN,NP)                    
      CALL CESD(SCOV,DVDP,RCELLN,NP)                
      WRITE(LPR,400)
      WRITE(LPR,410)                                
      WRITE(LPR,420)(CELLN(I),TCOV(I,I),I=1,3),(P(I),TCOV(
     2 I,I),I=4,6)                                                    
      WRITE(LPR,430)                                                  
      WRITE(LPR,440)(RCELLN(I),SCOV(I,I),I=1,3),(DVDP(I),    
     2 SCOV(I,I),I=4,6)              
      WRITE(LPR,450)                    
      WRITE(LPR,460)VS,E1,VOL,E2    
      VOL=1.0/VOL               
      RETURN                            
400   FORMAT(1H0,////10X,               
     2 'CELL PARAMETERS WITH ESTIMATED STANDARD DEVIATIONS')
410   FORMAT(1H0,5X,1HA,19X,1HB,19X,1HC,18X,5HALPHA,13X,4HBETA,15X,
     2 5HGAMMA)                                                    
420   FORMAT(1H ,3(F10.4,1H(,F8.4,1H)),3(F10.3,1H(,F6.3,1H)))      
430   FORMAT(1H0,5X,2HA*,18X,2HB*,18X,2HC*,17X,6HALPHA*,12X,5HBETA*,
     2 14X,6HGAMMA*)                                                
440   FORMAT(1H ,3(F10.6,1H(,F8.6,1H)),3(F10.3,1H(,F6.3,1H)))      
450   FORMAT(1H0,27X,4HREAL,16X,12HCELL VOLUMES,8X,10HRECIPROCAL)  
460   FORMAT(1H ,22X,F10.3,1H(,F6.3,1H),26X,F10.7,1H(,F10.7,1H))
      END                                                          
      SUBROUTINE CESD(TCOV,P,CELLN,NP)            
      DIMENSION TCOV(6,6),P(6)
      DIMENSION CELLN(6)     
      COMMON /GEOM/DEGRAD,RADDEG   
      DO 30 I=1,6                  
      IF(TCOV(I,I))10,30,20     
10    TCOV(I,I)=0.0             
      GOTO 30                      
20    TCOV(I,I)=SQRT(TCOV(I,I)) 
30    CONTINUE                        
      DO 40 I=4,6                     
      TCOV(I,I)=TCOV(I,I)*RADDEG
      P(I)=ACOS(CELLN(I))*RADDEG
40    CONTINUE                        
      RETURN                          
      END                             
      SUBROUTINE VESD(E,G,VOL,CELLN,RCELLN,TCOV,DVDP,NP) 
      DIMENSION CELLN(6),RCELLN(6)
      DIMENSION TCOV(6,6),DVDP(6)
      DO 10 I=1,3                        
      II=I+3                          
      DVDP(I)=VOL/CELLN(I)  
      DVDP(II)=-G*RCELLN(II)    
10    CONTINUE              
      E=0.0             
      DO 60 I=1,6       
      DO 50 J=I,6       
      IF(I-J)20,30,20   
20    TOO=2.0           
      GOTO 40           
30    TOO=1.0           
40    E=E+DVDP(I)*DVDP(J)*TCOV(I,J)*TOO 
50    CONTINUE        
60    CONTINUE        
      IF(E)70,90,80   
70    E=0.0           
      RETURN          
80    E=SQRT(E)       
90    RETURN          
      END             
      SUBROUTINE MATAB(RCOV,D,COV,NP) 
      DIMENSION RCOV(6,6),COV(6,6),D(6,6) 
      DO 30 I=1,6                           
      DO 20 J=1,6                           
      RCOV(I,J)=0.0       
      DO 10 M=1,6                           
      RCOV(I,J)=RCOV(I,J)+D(I,M)*COV(M,J) 
10    CONTINUE   
20    CONTINUE   
30    CONTINUE   
      RETURN     
      END        
      SUBROUTINE MATABT(RCOV,D,COV,NP) 
      DIMENSION RCOV(6,6),D(6,6),COV(6,6)
      DO 30 I=1,6                           
      DO 20 J=1,6                           
      RCOV(I,J)=0.0                      
      DO 10 M=1,6                           
      RCOV(I,J)=RCOV(I,J)+D(I,M)*COV(J,M)  
10    CONTINUE    
20    CONTINUE    
30    CONTINUE    
      RETURN      
      END         
      SUBROUTINE SHOUT(XL,FLAG,LP,STAND,FMT)
      DIMENSION STAND(70)
      DIMENSION FMT(70),DUM(70)
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14)                      
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     2 6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),HL(3,3),SA(70),SB(70),TEXT(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2 ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3 ICYCLE,KLOOP,LINES
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      DATA ONEH/4H(1H /,THRX/4H,3X /,AFOR/4H,A4 /,BLANK/4H    /
      WRITE(LPR,190)ICYCLE      
      FMT(1)=ONEH     
      FMT(2)=AFOR 
      FMT(3)=THRX 
      II=1        
      III=N       
      L=1         
      M=4         
      WRITE(LPR,200)
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      LGG=0
      ATEXT(N6)=BLANK
      DO 170 NP=1,NPAT
      N3=N6+NP          
      N2=N7+1          
      WRITE(LPR,260)NP,(PTEXT(NP,J),J=1,4) 
      N1=N+NP           
      WRITE(LPR,280)    
      ATEXT(N1)=BLANK   
      II=N1             
      III=N1            
      L=3
      M=3             
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      ATEXT(N3)=BLANK   
      II=N3             
      III=N3            
      L=1               
      M=3               
      WRITE(LPR,300)  
      WRITE(LPR,310)
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
170   CONTINUE
      ATEXT(N2)=BLANK
      II=N2          
      III=N2         
      L=1            
      M=3            
      WRITE(LPR,340) 
      WRITE(LPR,350) 
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      WRITE(LPR,360) 
      L=4            
      M=6            
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
180   RETURN              
190   FORMAT(1H1,40X,37HSHIFTS AND NEW PARAMETERS AFTER CYCLE,I2)      
200   FORMAT(5H0ATOM,6X,1HX,8X,5HSHIFT,4X,3HESD,7X,1HY,8X,5HSHIFT,4X,  
     23HESD,7X,1HZ,8X,5HSHIFT,4X,3HESD,7X,5HOCCUP,4X,5HSHIFT,4X,3HESD/)
230   FORMAT(1H+,91X,2F9.5)                                            
240   FORMAT(5H0ATOM,6X,3HB11,6X,5HSHIFT,4X,3HESD,7X,3HB22,6X,5HSHIFT, 
     24X,3HESD,7X,3HB33,6X,5HSHIFT,4X,3HESD/)                         
260   FORMAT(////,40X,18(1H*),/,40X,1H*,3X,7HPATTERN,1X,I2,3X,1H*,/,   
     240X,1H*,4A4,1H*,/,40X,18(1H*),/)                                
280   FORMAT(1H ,5X,6HSCALE ,3X,5HSHIFT,4X,3HESD,7X,6H      ,/)
300   FORMAT(1H0,13X,20H   UVW    PARAMETERS)                          
310   FORMAT(1H ,10X,1HU,9X,5HSHIFT,5X,3HESD,5X,1HV,9X,5HSHIFT,5X,     
     23HESD,5X,1HW,9X,5HSHIFT,5X,3HESD,3X)                            
330   FORMAT(2X,8H*PATTERN,I2,1H*)                                     
340   FORMAT(1H0,53X,15HCELL PARAMETERS)                               
350   FORMAT(1H ,10X,1HA,11X,5HSHIFT,7X,3HESD,10X,1HB,11X,5HSHIFT,7X,  
     23HESD,10X,1HC,11X,5HSHIFT,7X,3HESD/)                            
360   FORMAT(1H0,10X,1HD,11X,5HSHIFT,7X,3HESD,10X,1HE,11X,5HSHIFT,7X,  
     23HESD,10X,1HF,11X,5HSHIFT,7X,3HESD/)                            
      END                                                              
      FUNCTION FREL(I,J)                                               
      COMMON /RELX/RELAXB,RELAXC,RELAXS,RELAXH            
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT  
      NX=N+1
      IF(I-NX)10,20,20   
10    IF(J-4)60,70,30    
20    IF(I-N6)40,50,50   
30    IF(J-9)80,70,70    
40    GOTO(70,50,80,80,70),J 
50    FREL=RELAXH            
      RETURN           
60    FREL=RELAXC      
      RETURN           
70    FREL=RELAXB      
      RETURN        
80    FREL=RELAXS   
      RETURN        
      END           
      SUBROUTINE UPDATE(XL,FLAG,LP)  
      DIMENSION FLAG(110,14),XL(110,14),LP(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN        
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      DO 40 I=1,N4          
      CALL PARS(I,NPAR)     
      DO 30 J=1,NPAR        
      IF(LP(I,J))10,30,10   
10    IF(LP(I,J)-MATORD)20,20,30 
20    K=LP(I,J)                  
      REL=FREL(I,J)              
      XL(I,J)=XL(I,J)+FLAG(I,J)*DERIV(K)*REL
30    CONTINUE             
40    CONTINUE             
60    CALL SHIFT(XL)
      CALL REPCEL(RCELLN,AL)
      CALL TRCL(RCELLN,CELLN,VOL)
      RETURN               
      END                  
      SUBROUTINE PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      DIMENSION STAND(70)
      DIMENSION DUM(70),FMT(70)
      DIMENSION XL(110,14),LP(110,14),FLAG(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),TEXT(20)
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      DATA ONEX/4H,1X /,THR/4H,3  /,FONE/4H,F9 /,FONEB/                
     24HF9  /,FTWO/4H,F12/,FTWOB/4HF12 /,PONE/4H.5  /,PTWO/4H.8  /,   
     3PTHR/4H.0  /,XONE/4H,18X/,XTWO/4H,24X/,                         
     4END/4H)   /,BLANK/4H    /    
      DO 5 IBL=4,70   
    5 FMT(IBL)=BLANK  
      FTEN=FONE    
      FTENB=FONEB  
      PT5=PONE     
      ATEENX=XONE  
      IF(III-N3)40,10,30
10    IF(M-3)20,20,40 
20    PT5=PTHR
      GOTO 40       
30    FTEN=FTWO
      FTENB=FTWOB
      PT5=PTWO   
      ATEENX=XTWO
40    DO 100 I=II,III 
      INDEX=3         
      KK=0            
      CHAR=ATEXT(I)   
      CALL XCOPY(KK,CHAR,DUM) 
      DO 90 J=L,M             
      CHAR=XL(I,J)            
      CALL XCOPY(KK,CHAR,DUM) 
      K=LP(I,J)             
      IF(K)70,70,50         
50    IF(K-MATORD)60,60,70  
60    REL=FREL(I,J)         
      CHAR=DERIV(K)*FLAG(I,J)*REL
      CALL XCOPY(KK,CHAR,DUM)    
      CHAR=STAND(K)*ABS(FLAG(I,J)) 
      CALL XCOPY(KK,CHAR,DUM)      
      CALL XCOPY(INDEX,THR,FMT)    
      CALL XCOPY(INDEX,FTENB,FMT)  
      CALL XCOPY(INDEX,PT5,FMT)    
      GOTO 80                      
70    CALL XCOPY(INDEX,FTEN,FMT)   
      CALL XCOPY(INDEX,PT5,FMT)    
      CALL XCOPY(INDEX,ATEENX,FMT) 
80    CALL XCOPY(INDEX,ONEX,FMT)   
90    CONTINUE                     
      CALL XCOPY(INDEX,END,FMT)    
      WRITE(LPR,FMT)(DUM(K),K=1,KK)
100   CONTINUE                     
      RETURN
      END
*     Subroutine open_read1 opens a file for reading, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
*
*     file formatted
*
      subroutine open_read1(unit,file,extension)
      integer unit
      character*(*) file,extension
      open (unit,file=file,status='old',defaultfile=extension,
     - readonly)
      return
      end
*
*     Subroutine open_read2 opens a file for reading, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
*
*     file unformatted
*
      subroutine open_read2(unit,file,extension)
      integer unit
      character*(*) file,extension
      open (unit,file=file,status='old',defaultfile=extension,
     - form='unformatted')
      return
      end
*
*
*     Subroutine open_write1 opens a file for writing, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
*     file formatted
*
      subroutine open_write1(unit,file,extension)
      integer unit
      character*(*) file,extension
      open (unit,file=file,status='new',defaultfile=extension,
     - carriagecontrol='list')
      return
      end
*
*     Subroutine open_write2 opens a file for writing, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
*     file unformatted
*
      subroutine open_write2(unit,file,extension)
      integer unit
      character*(*) file,extension
      open (unit,file=file,status='new',defaultfile=extension,
     - carriagecontrol='list',form='unformatted')
      return
      end
*
*
*     Subroutine open_write3 opens a file for writing, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
*     file unformatted scratch
*
      subroutine open_write3(unit,file,extension)
      integer unit
      character*(*) file,extension
      open (unit,file=file,status='new',defaultfile=extension,
     - carriagecontrol='list',form='unformatted',disp='delete')
      return
      end
*
